+++
title = "Sauvegarder sa BDD et la restaurer"
date = 2020-04-14
description = "Exporter/Importer une base de données avec mariadb :sourire:"
template = "articles.html"
+++

### D'abord l'export: 
 L'outil s'appelle mysqldump il est installé avec mariadb-server.
 
 Donc on peut d'abord lister les base données pour être sûr de celle 
 que l'on veut exporter ? 

```bash
$ mysql -u root -p 
MariaDB [(none)]> SHOW DATABASES;
+--------------------+
| Database           |
+--------------------+
| test1              |
| information_schema |
| mysql              |
| nextcloud          |
| performance_schema |
| test               |
+--------------------+

```

Si par exemple on veut exporter la base nextcloud on tapera ceci 
dans notre shell:

``` bash
$ mysqldump -u root -p nextcloud > nextcloud_export.sql
``````

### Importer sa base de données 

Pour importer notre fichier on va devoir créer la base et l'utilisateur qui aura
les droits sur la base. 

```bash
$ mysql -u root -p 
MariaDB [(none)]> CREATE DATABASE nextcloud;
MariaDB [(none)]> CREATE USER nextbase IDENTIFIED BY 'example';
MariaDB [(none)]> GRANT ALL PRIVILEGES ON nextcloud.* TO nextbase;
MariaDB [(none)]> FLUSH PRIVILEGES;
MariaDB [(none)]> exit;
```

Si tout se passe bien normalement à la fin de chaque commande mysql 
vous verrez un message Query OK ... , c'est que c'est bon :).

Maintenant on va pouvoir importer notre fichiers comme ceci : 

``` bash
$ mysql -u nextbase -p nextcloud < nextcloud_export.sql
```

Si vous n'avez aucun message d'erreur, c'est fini ! 
