+++
template = "articles.html"
title = "Les logiciels libres"
description = "Pourquoi utiliser des logiciels libres"
date = 2017-01-29
+++

Bonjour chers lecteurs·trices, comme vous ne le savez peut-être
pas; j'utilise **et recommande** autant que faire se peut des logiciels libres.
Ces derniers répondent a quatre lois de bases qui ont des
conséquences pour les utilisateurs. A travers divers exemples, je tenterai
de vous faire comprendre l'intérêt qu'a la licence d'un programme. 


### La liberté d'exécuter le logiciel pour n'importe quel usage.
En effet, certaines licences vous interdisent d'utiliser le
programme comme vous l'entendez, par exemple : Vous installer un
antivirus et au bout d'une période d'essai il ne fonctionne plus car
il faut **activer/acheter** la licence ( ils ont des termes j'vous jure). 
Quand vous acheter un programme comme Microsoft office, on vous 
permet de l’installer sur un nombres d’ordinateurs définis par 
Microsoft. Souvent il s’agit d’un ordinateur, si vous avez un 
ordinateur de bureau et un portable hé bien vous aurez 2 licences
à acheter. Simple et efficace mais pour qui ? 

### La liberté d'étudier le fonctionnement d'un programme et de l'adapter à ses besoins.
Cela implique que le code source du programme doit vous
être fourni sur demande ou directement à l’achat ou téléchargement
du logiciel. On peut vérifier ce qu'un programme fait quand on
lis son code pas quand on vois ce qu'il fait… Un exemple concret, l’application
Flashlight qui a été présente sur le Playstore, les gens voyaient que le flash 
s’allumait mais que leur coordonnées bancaire était envoyées sur un 
ordinateur à travers Internet. 
Cela reste un cas rare, mais des cas de vol d’informations personnelles envoyer
par des applications sans en avertir les utilisateurs est très répandu 
par contre. Vous pouvez aller voir [ce
projet](https://exodus-privacy.eu.org/fr) pour vous en convaincre. 

Il se peut aussi que le logiciel vous intéresse mais il n'est pas
adapté à vos besoins ou votre infrastructure. Avec le logiciel libre,
vous pouvez payer un développeur pour adapter le programme a vos besoins.
Et en informatique adapter des programmes existant c'est assez répandu. 
D'autre part si vous êtes une boîte de développement cela vous donne 
l'occasion de montrer votre savoir-faire.


### La liberté de redistribuer des copies.
Bon là tout le monde connaît et sait de quoi on parle … Sachez que
quand vous partagez une logiciel, par exemple une application d’un 
jeux sur Android le simple fait de partager une paquet (.apk) avec 
vos amis peut-être interdit. Mine de rien quand on sait que l'on est 
en tord de partager un logiciel avec un amis ou quelqu'un qu'on aime
bien car on sait pertinament que ca ne fonctionnera, cela ne pousse
pas a l'entraide entre les gens dans une société.

### L'obligation de faire bénéficier à la communauté des versions modifiées.
Alors sur ce point un petite explication s'impose. Si vous modifiezun
programme et que vous le gardez pour vous, pas de problème. 
Par contre si vous partagez/vendez ce logiciel, alors vous devez 
fournir le code source modifié.


Il y a de multiples exemples où le logiciel libre a beaucoup 
d'avantages, qui découlent de ces quatre libertés. Les effets sur 
la société sont aussi important bien que cela demande un article
complet le logiciel libre prône plus des valeurs de partages que les 
valeurs de la possession. La transparence de l’éditeur du logiciel
face aux bénéfices de l’éditeur envers ces utilisateurs.


### Mais qui a eu cette idée folle ?

Ce n'est pas Charlemagne mais Richard Stallman qui le
4 octobre 1985 fonde la FSF et officialise du coup le projet GNU rassemblant
tout les programmes essentiels pour avoir un système d'exploitation libre
créé un an avant.
Aujourd'hui la Fondation s'emploie à promouvoir et faire respecter sa
licence: la GPL (en version 3 a l'heure actuelle). Elle finance aussi divers
projets dans des domaines où le logiciel libre manque de solution. [Ça se passe ici](https://www.fsf.org/campaigns/priority-projects)




Voila ! c'est fini pour cet article j'espère qu'il vous aura
fait découvrir pas mal de choses.
